#include "stdafx.h"
#include "vector.h"
#include "CPow.h"

extern int randInt(int min, int max);

CPow::CPow()
{
	spawn(CPoint(10, 10), CPoint(0, 1), CPoint(5,0));
}

void CPow::spawn(CPoint pPos, CPoint pDir, CPoint pPt)
{
	active = true;
	Pos.ex = pPos.x;
	Pos.ey = pPos.y;
	Pt.ex = pPt.x;
	Pt.ey = pPt.y;
	Dir.ex = pDir.x;
	Dir.ey = pDir.y;
	Dir *= 0.2;

	ttl = 250;
}

void CPow::onTick(CRect &rc)
{
	if(active)
	{
		Pos += Dir;
		Pos %= rc.Size();
		Pt.rotate(30);
		ttl--;
	}
	if(!ttl)
		active = false;
}
	
void CPow::paint(CDC &rdc)
{
	CPen NewPen;
	NewPen.CreatePen(PS_SOLID,1,RGB(randInt(0, 255),randInt(0, 255),randInt(0, 255)));
    CPen * pOldPen=rdc.SelectObject(&NewPen);
	VECTOR temp = Pt * 1.5;
	if(active)
	{
		for(int i=1; i<5; i++)
		{
			rdc.MoveTo(Pos);
			rdc.LineTo(Pos + temp);
			temp.rotate(90*i);
		}
	}
	NewPen.DeleteObject(); 
}

void CPow::onHit(ship &sh)
{
	int wtype;
	active = false;
	switch(effect)
	{
	case 0:
	case 2:
	case 7:
	case 8:
	case 9:
		wtype = randInt(0,4);
		switch(wtype)
		{
			case 0:
				sh.pw =& G_SINGLEFIRE;
				break;
			case 1:
				sh.pw =& G_SPREADFIRE;
				break;
			case 2:
				sh.pw =& G_PULSEMINE;
				break;
			case 3:
				sh.pw =& G_SIDESHOT;
				break;
			case 4:
				sh.pw =& G_RINGOFDOOM;
				break;
		}
		break;
	case 3:
		sh.tabooCount = 150;
		break;
	case 5:
		sh.invCount = 100;
		break;
	case 4:
		sh.hp++;
		sh.hp++;
	case 6:
		sh.hp++;
		sh.hp++;
		break;
	}
}