#include "stdafx.h"
#include "CSentry.h"

CSentry::CSentry()
{
	Pos.ex = 0;
	Pos.ey = 0;
	Pt.ex = 0;
	Pt.ey = 10;
	hp = 20;
	numBulls = 0;
	score = 0;
	deaths = 0;
	automatic = true;
}

CSentry::CSentry(CPoint spos, CPoint spt, int shp)
{
	numBulls = 0;
	spawn(spos, spt, shp);
}

void CSentry::spawn(CPoint spos, CPoint spt, int shp)
{
	Pos.ex = spos.x;
	Pos.ey = spos.y;
	Pt.ex = spt.x;
	Pt.ey = spt.y;
	hp = shp;
}

void CSentry::paint(CDC &rdc)
{
	CPen NewPen;
	NewPen.CreatePen(PS_SOLID,1,RGB(255,255,255));
    CPen * pOldPen=rdc.SelectObject(&NewPen);

	double cx; double cy;
	double l = Pt.length();
	double angl = Pt.angle()-8;

	cx = (Pt.ex - 4 * cos(Pt.dtor(angl)));
	cy = (Pt.ey - 4 * sin(Pt.dtor(angl)));
	rdc.MoveTo(Pos);
	rdc.LineTo(Pos+Pt*2);
	rdc.LineTo(Pos - Pt);
	rdc.MoveTo(Pos+Pt);
	rdc.LineTo(int(cx+Pos.ex-Pt.ex), int(cy+Pos.ey-Pt.ey));

	rdc.MoveTo(cx+Pos.ex-Pt.ex, cy+Pos.ey-Pt.ey);
	rdc.LineTo(Pos - Pt);
	angl -= 150;
	cx = (Pt.ex + 4 * cos(Pt.dtor(angl)));
	cy = (Pt.ey + 4 * sin(Pt.dtor(angl)));
	rdc.LineTo(Pos - Pt);
	rdc.MoveTo(Pos+Pt);
	rdc.LineTo(cx+Pos.ex-Pt.ex, cy+Pos.ey-Pt.ey);
	rdc.MoveTo(cx+Pos.ex-Pt.ex, cy+Pos.ey-Pt.ey);
	rdc.LineTo(Pos - Pt);

	NewPen.DeleteObject();
}

void CSentry::turnLeft()
{ Pt.rotate(-10); }

void CSentry::turnRight()
{ Pt.rotate(10); }

void CSentry::reset(int bullID)
{
	b[bullID].active = true;
	b[bullID].Dir = Pt * 2 + Dir;
	b[bullID].Pos = Pos;
	b[bullID].ttl = 10;
	b[bullID].active = true;
	numBulls++;
}
void CSentry::tick(CRect &rc)
{
	for(int i=0; i<10; i++)
	{
		if(b[i].active)
			b[i].onTick(rc);
	}
}

int CSentry::giveFreeBulletID()
{
	for(int i=0; i<10; i++)
	{
		if(!b[i].active)
			return i;
	}
	return -1;
}

void CSentry::target(ship &sh)
{
	VECTOR sPos = Pos;
	VECTOR sPt = sh.Pos;
	VECTOR temp = sPt - sPos;
	int freeBullet = giveFreeBulletID();
    
	double seAngle = Pt.angle();
	if(seAngle < 0)
		seAngle += 360;
	
	double angl = seAngle - temp.angle();
	angl = int(angl + 360) % 360;

	if(angl > -5 && angl < 5 && freeBullet >= 0)
	{
		if(temp.length() < 250)
  			reset(freeBullet);
	}
	else if(angl > 180)
		Pt.rotate(5);
	else if(angl < 180)
		Pt.rotate(-5);

}
