#include "StdAfx.h"
#include "ship.h"
#include "CWeapon.h"

#include "vector.h"
#include "bullet.h"
#include <math.h>

pulseMine G_PULSEMINE;
singleFire G_SINGLEFIRE;
spreadFire G_SPREADFIRE;
sideShot G_SIDESHOT;
ringOfDoom G_RINGOFDOOM;

void CWeapon::fire(ship &sh)
{ ; }

void singleFire::fire(ship &sh)
{
	if(sh.coolDown > 0) return;
	int first = sh.giveFreeBulletID();
	if(first < 0)
		return;
	sh.b[first].active = true;
	sh.b[first].Dir = sh.Pt * 3.0 + sh.Dir;
	sh.b[first].Pos = sh.Pos;
	sh.b[first].ttl = MAX_MISSILE_LIFE - 7;
	sh.coolDown = 2;
	sh.numBulls++;
}

void spreadFire::fire(ship &sh)
{
	if(sh.coolDown > 0) return;
	int first;
	int count = 0;
	for(int i=0; i<10; i++)
	{
		if(!sh.b[i].active)
			count++;
	}
	if(count < 3)
		return;

	for(i=0; i<3; i++)
	{
		first = sh.giveFreeBulletID();
		sh.b[first].active = true;
		sh.b[first].Dir = sh.Pt * 2.5 + sh.Dir * 0.5;
		sh.b[first].Dir.rotate(-5 + i * 5);
		sh.b[first].Pos = sh.Pos;
		sh.b[first].ttl = MAX_MISSILE_LIFE - 7;
		sh.coolDown = 6;
		sh.numBulls++;
	}
}

void pulseMine::fire(ship &sh)
{
	int first;
	int count = 0;

	for(int i=0; i<10; i++)
	{
		if(!sh.b[i].active)
			count++;
	}
	if(count < 10)
		return;

	for(i=0; i<10; i++)
	{
		first = sh.giveFreeBulletID();
		sh.b[first].active = true;
		sh.b[first].Dir = sh.Pt;
		sh.b[first].Dir.setLength(1);
		sh.b[first].Dir.rotate(i * 36 - 45);
		sh.b[first].Pos = sh.Pos;
		sh.b[first].ttl = MAX_MISSILE_LIFE;
		sh.numBulls++;
	}
}

void sideShot::fire(ship &sh)
{
	if(sh.coolDown > 0) return;
	int first;
	int count = 0;

	for(int i=0; i<10; i++)
	{
		if(!sh.b[i].active)
			count++;
	}
	if(count < 3)
		return;

	first = sh.giveFreeBulletID();
	sh.b[first].active = true;
	sh.b[first].Dir = sh.Pt * 3;
	sh.b[first].Dir += sh.Dir;
	sh.b[first].Pos = sh.Pos;
	sh.b[first].ttl = MAX_MISSILE_LIFE-5;

	first = sh.giveFreeBulletID();
	sh.b[first].active = true;
	sh.b[first].Dir = sh.Pt * 3;
	sh.b[first].Dir += sh.Dir;
	sh.b[first].Pos = sh.Pos;
	sh.b[first].ttl = MAX_MISSILE_LIFE-5;

	first = sh.giveFreeBulletID();
	sh.b[first].active = true;
	sh.b[first].Dir = sh.Pt * 3;
	sh.b[first].Dir += sh.Dir;
	sh.b[first].Pos = sh.Pos;
	sh.b[first].ttl = MAX_MISSILE_LIFE-5;

	sh.coolDown = 6;
}

void ringOfDoom::fire(ship &sh)
{
	if(sh.coolDown > 0) return;
	int first;
	for(int i=0; i<5; i++)
	{
		first = sh.giveFreeBulletID();
		if(first < 0)
			return;
		sh.b[first].active = true;
		sh.b[first].Dir = sh.Pt * 2;
		sh.b[first].Dir.rotate(72 * i);
		sh.b[first].Pos = sh.Pos;
		sh.b[first].ttl = 2;
		sh.numBulls++;
	}
	sh.coolDown = 0;
}