
// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "winSpace.h"
#include "ChildView.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////////////////

int randInt(int min, int max);

//////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
	MAX_SHIPS = 3;
	for(int i=1; i<ABS_MAX_SHIPS+1; i++)
		s[i-1].spawn (randInt(1, 500), randInt(1, 500), 0, 0, 7.07, 0.0);

	for(i=0; i<ABS_MAX_SHIPS; i++)
		s[i].shipID = i;

	s[0].CreateMyPen(RGB(255,0,0));
	s[1].CreateMyPen(RGB(0,255,0));
	s[2].CreateMyPen(RGB(0,0,255));
	s[3].CreateMyPen(RGB(200,200,0));
	s[4].CreateMyPen(RGB(0,200,200));
	s[5].CreateMyPen(RGB(200,0,200));

	sentry.spawn(CPoint(randInt(1,300), randInt(1,300)), CPoint(0,10), 15);
	sentry.score = 0;	

	s[0].ai = false;
	pause = false;
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
//	ON_WM_KEYDOWN()
//	ON_WM_KEYUP()
	ON_WM_CHAR()
	ON_WM_TIMER()
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
	ON_WM_KEYUP()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC realDC(this);
	CRect r;
	GetClientRect(r);
	dc.FillSolidRect(r, RGB(0x0, 0x0, 0x0));
	dc.SetTextColor(RGB(255, 255, 255));

	char score[32];
	for(int j=0; j<MAX_SHIPS; j++)
	{
		s[j].Paint(dc);
		shr[j].Paint(dc);
	}
	
	for(int q=0; q<10; q++)
		sentry.b[q].Paint(dc);
	sentry.paint(dc);	

	for(j=0; j<MAX_SHIPS;j++)
	{
		dc.SetTextColor(s[j].myColor);
		itoa(s[j].score, score, 10);
		dc.TextOut(j*30 + 100, 10, score);
		itoa(s[j].deaths, score, 10);
		dc.TextOut(j*30 + 100, 30, score);
	}
	dc.SetTextColor(RGB(0xFF, 0xFF, 0xFF));

	for(j=0; j<MAX_POW; j++)
		pow[j].paint(dc);

	itoa(sentry.score, score, 10);
	dc.TextOut(300,10, score);
	itoa(sentry.deaths, score, 10);
	dc.TextOut(300,30, score);

	dc.TextOut(10, 10, "Score:");
	dc.TextOut(10, 30, "Deaths:");

	realDC.BitBlt(r.left, r.top, r.Width(), r.Height(), &dc, 0, 0, SRCCOPY);
}

void CChildView::OnTimer(UINT nIDEvent) 
{
	if(pause)
	{
		CWnd ::OnTimer(nIDEvent);
		return;
	}

	CRect rc;
	GetClientRect(&rc);

	int j;
	int k;
	int i;

	for(i=0; i<MAX_SHIPS; i++)
		s[i].tick(rc);
	sentry.tick(rc);
	for(i=0; i<MAX_SHIPS; i++)
		shr[i].onTick(rc);

	checkkeys();
	CheckHit();
	

	for(k=0; k<MAX_POW; k++)
		pow[k].onTick(rc);

	if(sentry.automatic)
	{
		int shortest = 1000;
		int idShortest = 0;

		VECTOR temp0;
		for(k=0; k<MAX_SHIPS; k++)
		{
			temp0 = sentry.Pos - s[k].Pos;
			if(temp0.length() < shortest && (s[k].tabooCount <= 0))
			{
				shortest = temp0.length();
				idShortest = k;
			}
		}

		sentry.target(s[idShortest]);
	}

	for(k=0; k<MAX_SHIPS; k++)
	{
		if(s[k].ai && s[k].target < MAX_SHIPS && s[k].target != s[k].shipID)
		{
			s[k].aitarget(s[s[k].target]);
		}
		else if(s[k].ai && s[k].target == 6)
			s[k].aitarget(sentry);
		else if(s[k].ai)
			s[k].target = s[k].aiPickTarget();
	}

	for(k=0; k<MAX_SHIPS; k++)
	{
		if(s[k].tabooCount)
			s[k].tabooCount--;
		if(s[k].invCount)
			s[k].invCount--;
	}
	Invalidate();
	CWnd ::OnTimer(nIDEvent);
}

void CChildView::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CWnd ::OnShowWindow(bShow, nStatus);
	SetTimer(1, 25, NULL);
	// TODO: Add your message handler code here
	
}

void CChildView::CheckHit()
{
	CRect foo;
	CRect rsent = sentry.grabRect();
	for(int i=0; i<MAX_SHIPS; i++)		//For each ship's (bullets)
	{
		for(int k=0; k<MAX_SHIPS; k++)  //Grab the checking ship's rect
		{
			foo = s[k].grabRect();
			for(int j=0; j<10; j++)		//For (enemy) each bullet
			{
				if(s[i].b[j].active && i != k) //check to see if enemy hits me
				{
					if(foo.PtInRect(s[i].b[j].Pos) && !s[k].invCount)
					{
						s[k].hp--;
						s[k].hit = true;
						s[i].score++;
						s[i].b[j].active = false;
						if(!s[k].hp)
						{
							for(int f=0; f<MAX_POW; f++)
							{
								if(!pow[f].active)
								{
									pow[f].spawn(s[k].Pos, s[k].Dir/2, 
										s[k].Pt);
									break;
								}
							}
							shr[k].spawn(s[k]);
							s[k].spawn(randInt(1, 500), randInt(1, 500),
								s[k].Dir.ex/4, s[k].Dir.ey/4, 5.0, 5.0);
							s[k].deaths++;
							s[k].score -= 5;
							foo = s[k].grabRect();
							
						}						
					}
					if(rsent.PtInRect(s[i].b[j].Pos)) //Check for hits on sentry
					{
						s[i].b[j].active = false;

						sentry.hp--;
						if(sentry.hp <= 0)
						{
							for(int f=0; f<MAX_POW; f++)
							{
								if(!pow[f].active)
								{
									pow[f].spawn(CPoint(sentry.Pos.ex, sentry.Pos.ey),
										CPoint(randInt(1, 5), randInt(1,5)),
											CPoint(5,0));
								}
							}
							sentry.spawn(CPoint(randInt(1, 300), randInt(1,300)),
								 CPoint(10, 0), 15);
							sentry.deaths++;
							sentry.score -= 5;
                        	s[i].score += 10;
						}
					}					
				}
					//check the Sentry's shots
				if(!s[k].invCount && sentry.b[j].active && foo.PtInRect(sentry.b[j].Pos))
				{
					sentry.b[j].active = false;

					s[k].hp--;		
					s[k].hit = true;
					sentry.score++;
					if(!s[k].hp)
					{
						shr[k].spawn(s[k]);
						s[k].spawn(randInt(1, 500), randInt(1, 500),
						s[k].Dir.ex/4, s[k].Dir.ey/4, 5.0, 5.0);
						s[k].deaths++;
						s[k].score -= 1;
						
					}
				}
				for(int f=0; f<MAX_POW; f++)
				{
					if(pow[f].active && foo.PtInRect(pow[f].Pos))
					{
						int pEffect = randInt(0,9);  //Determine powerup's type
						pow[f].effect = pEffect;
						pow[f].onHit(s[k]);

					}
				}

			}
		}
	}
}

void CChildView::checkkeys()
{
	BYTE keyboard[256];
	GetKeyboardState(keyboard);

	if(keyboard[VK_LEFT] & 0x80 && !s[0].ai)
		s[0].turnLeft();
	if(keyboard[VK_RIGHT] & 0x80 && !s[0].ai)
		s[0].turnRight();
	if(keyboard[VK_UP] & 0x80 && !s[0].ai)
		s[0].accelerate(1);
	if(keyboard[VK_DOWN] & 0x80 && !s[0].ai)
		s[0].accelerate(-1);
	if(keyboard[VK_RETURN] & 0x80 && !s[0].ai && s[0].coolDown <= 0)
		s[0].pw->fire(s[0]);

	if(keyboard['A'] & 0x80 && (MAX_SHIPS > 1) && !s[1].ai)
		s[1].turnLeft();
	if(keyboard['D'] & 0x80 && (MAX_SHIPS > 1) && !s[1].ai)
		s[1].turnRight();
	if(keyboard['S'] & 0x80 && (MAX_SHIPS > 1) && !s[1].ai)
		s[1].accelerate(-1);
	if(keyboard['W'] & 0x80 && (MAX_SHIPS > 1) && !s[1].ai)
		s[1].accelerate(1);
	if(keyboard[VK_SPACE] & 0x80 && (MAX_SHIPS >1) && !s[1].ai && s[1].coolDown <= 0)
		s[1].pw->fire(s[1]);

	//Player 3 controls
	if(keyboard[VK_NUMPAD4] & 0x80 && (MAX_SHIPS > 2) && !s[2].ai)
		s[2].turnLeft();
	if(keyboard[VK_NUMPAD6] & 0x80 && (MAX_SHIPS > 2) && !s[2].ai)
		s[2].turnRight();
	if(keyboard[VK_NUMPAD5] & 0x80 && (MAX_SHIPS > 2) && !s[2].ai)
		s[2].accelerate(-1);
	if(keyboard[VK_NUMPAD8] & 0x80 && (MAX_SHIPS > 2) && !s[2].ai)
		s[2].accelerate(1);
	if(keyboard[VK_ADD] & 0x80 && (MAX_SHIPS > 2) && !s[2].ai && s[2].coolDown <= 0)
		s[2].pw->fire(s[2]);

	//Sentry controls
	if(keyboard['J'] & 0x80 && !sentry.automatic)
		sentry.turnLeft();
	if(keyboard['K'] & 0x80 && !sentry.automatic)
		sentry.turnRight();
	if(keyboard['L'] & 0x80 && !sentry.automatic)
	{
		int freeBull = sentry.giveFreeBulletID();
		sentry.reset(freeBull);
	}

}

int randInt(int min, int max)
{
	int n;
	time_t seed;
	srand(rand() * rand() * (7* time(&seed)) );
	do
		n = rand() % (max+1);
	while( n < min && n > max);
	return n;
}

void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if(nChar == 27)
		exit(0);

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CChildView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
{
    if(nChar == VK_F3)
	{
		if(s[2].ai)
			s[2].ai = false;
		else s[2].ai = true;
	}
	else if(nChar == VK_F2)
	{
		if(s[1].ai)
			s[1].ai = false;
		else s[1].ai = true;
	}
	else if(nChar == VK_F1)
	{
		if(s[0].ai)
			s[0].ai = false;
		else s[0].ai = true;
	}
	else if(nChar == VK_F4)
	{
		if(sentry.automatic)
			sentry.automatic = false;
		else sentry.automatic = true;
	}
	else if(nChar == 'p' || nChar == 'P')
	{
		if(!pause)
			pause = true;
		else if(pause)
			pause = false;
	}
	else if(nChar == VK_PRIOR && (MAX_SHIPS < ABS_MAX_SHIPS))
	{
		MAX_SHIPS++;
	}

	else if(nChar == VK_NEXT && (MAX_SHIPS > 2))
	{
		MAX_SHIPS--;
	}

	CWnd::OnKeyUp(nChar, nRepCnt, nFlags);
}

void CChildView::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);
	CRect r;
	GetClientRect(r);
	CDC* realDC = GetDC();
	if(dc.GetSafeHdc())
	{
		dc.DeleteDC();
		m_BitmapBuffer.DeleteObject();
	}
	dc.CreateCompatibleDC(realDC);
	m_BitmapBuffer.CreateCompatibleBitmap(realDC, r.Width(), r.Height());
	dc.SelectObject(m_BitmapBuffer);

}

BOOL CChildView::OnEraseBkgnd(CDC* pDC)
{
	return false;
}
