#include "StdAfx.h"
#include "vector.h"
#include <math.h>

VECTOR::VECTOR()
{
//  bx=0;
//  by=0;
  ex=0;
  ey=0;
//  angl = 0;
}

VECTOR::VECTOR(double x2, double y2)
{
//  bx=x1;
//  by=y1;
  ex=x2;
  ey=y2;
}

VECTOR::VECTOR(const VECTOR &v1)
{
//  bx = v1.bx;
//  by = v1.by;
  ex = v1.ex;
  ey = v1.ey;
//  angl = v1.angl;
}

const VECTOR& VECTOR::operator += (const VECTOR &v1)
{
  ex += v1.ex;// - v1.bx;
  ey += v1.ey;// - v1.by;
  return *this;
}

const VECTOR& VECTOR::operator -= (const VECTOR &v1)
{
  ex -= v1.ex;// - v1.bx;
  ey -= v1.ey;// - v1.by;
  return *this;
}

const VECTOR& VECTOR::operator *= (double d)
{
	if(ex == 0.0)
		ex = 0.1;
	if(ey = 0.0)
		ey = 0.1;
  ex *= d;
  ey *= d;
  return *this;
}

const VECTOR& VECTOR::operator /= (double d)
{
	if(ex == 0.0)
		ex = 0.1;
	if(ey = 0.0)
		ey = 0.1;
  if(d != 0)
  {
	 ex /= d;
	 ey /= d;
  }
  return *this;
}

VECTOR VECTOR::operator + (const VECTOR &v1)
{
  VECTOR temp(*this);
  temp += v1;
  return temp;
}

VECTOR VECTOR::operator - (const VECTOR &v1)
{
  VECTOR temp(*this);
  temp -= v1;
  return temp;
}

VECTOR VECTOR::operator * (double d)
{
  VECTOR temp(*this);
  temp.ex *= d;
  temp.ey *= d;
  return temp;
}

VECTOR VECTOR::operator / (double d)
{
  VECTOR temp(*this);
  if(d != 0)
  {
	 temp.ex /= d;
	 temp.ey /= d;
  }
  return temp;
}

const VECTOR& VECTOR::operator %= (CSize size)
{
	int q = int(ex / size.cx);
	if (ex < 0)
		q--;
	ex = ex - (q * size.cx);
	q = int(ey / size.cy);
	if (ey < 0)
		q--;
	ey = ey - (q * size.cy);
	return *this;
}

VECTOR VECTOR::operator % (CSize size)
{
	VECTOR temp(*this);
	temp %= size;
	return temp;
}

const VECTOR& VECTOR::operator = (const VECTOR &v1)
{
// bx = v1.bx;
// by = v1.by;
 ex = v1.ex;
 ey = v1.ey;
 return *this;
}

const VECTOR& VECTOR::operator %= (CRect r)
{
	int q = int(ex / r.Width());
	if (ex < 0)
		q--;
	ex = ex - (q * r.Width());
	q = int(ey / r.Height());
	if (ey < 0)
		q--;
	ey = ey - (q * r.Height());
	return *this;
}

/**********************************/
/*
ostream& operator <<(ostream & os, const VECTOR& v1)
{
  return os << v1.bx << ' ' << v1.by << ' ' << v1.ex << ' ' << v1.ey;
}
*/
void VECTOR::rotate(double degrees)
{
	double l = length();
	double angl = angle() + degrees;
	ex = l * (cos(dtor(angl)));
	ey = l * (sin(dtor(angl)));
}

double VECTOR::angle() 
{
	if(ex==0)
	{
		if(ey > 0)
			return 90;
		else
			return -90;
	}
	if(ex > 0)
		return rtod(atan(ey/ex));

	return rtod(atan(ey/ex))+180;
}

VECTOR::operator CPoint() const
{
	return CPoint((int)ex, (int)ey);
}

void VECTOR::setLength(double desiredLen)
{
	double ratio = desiredLen / length();
	ex *= ratio;
	ey *= ratio;
}